function backgroundClick() {
    d3.selectAll("rect,path")
      .attr("data-highlight", "");    
}

function nodeClick(d) {
	// Removes previous selection
	d3.event.stopPropagation();
    d3.selectAll("rect,path").filter('[data-highlight="select"]')
		.attr("data-highlight", "");
			
	d3.select(this).attr("data-highlight", "select");    
	d.reference.forEach( function (path, index, array){
			d3.select(path.element)
				.attr("data-highlight", "select");

	});
	editor.gotoLine(d.lines[0]+1);
	
}

function nodeMouseover(d){ 
	// Updates this element if its data-highlight is not already on
	d3.select(this).filter('[data-highlight=""]')
		.attr("data-highlight", "hover");
	
	d.reference.forEach( function (path, index, array){
			d3.select(path.element).filter('[data-highlight=""]')
				.attr("data-highlight", "hover");

	});
	
	
	d3.select(this).filter('[data-highlight=""]')
		.attr("data-highlight", "hover");
	
	// Fade all others
	d3.selectAll("rect,path").filter('[data-highlight=""]')
		.attr("data-highlight", "fade");
}

function nodeMouseout(d){ 
	// Updates this element if  its data-highlight is on in hover mode
	// This is to prevent a clicked/selected node from being turned off.
	d3.selectAll("rect,path").filter('[data-highlight="fade"]')
		.attr("data-highlight", "");
		
	d.reference.forEach( function (path, index, array){
			d3.select(path.element).filter('[data-highlight="hover"]')
				.attr("data-highlight", "");

	});
		
	d3.select(this).filter('[data-highlight="hover"]')  
		.attr("data-highlight", "");						
}

function pathMouseover(d) {
    d3.select(this).filter('[data-highlight=""]')
		.attr("data-highlight", "hover");

	d.reference.forEach( function (node, index, array){
			d3.select(node.element).filter('[data-highlight=""]')
				.attr("data-highlight", "hover");

	});
	
	// Fade all others
	d3.selectAll("rect,path").filter('[data-highlight=""]')
		.attr("data-highlight", "fade");
}

function pathMouseout(d) {
	d3.selectAll("rect,path").filter('[data-highlight="fade"]')
		.attr("data-highlight", "");
		
    d.reference.forEach( function (node, index, array){
			d3.select(node.element).filter('[data-highlight="hover"]')
				.attr("data-highlight", "");

	});
		
	d3.select(this).filter('[data-highlight="hover"]')  
		.attr("data-highlight", "");	
}


function highlightNode(n) {
    d3.selectAll('[data-highlight = "select"]')
      .attr("data-highlight", "");
    for (var i = 0; i < nodesMap[n].length; i++) {
        d3.select(nodesMap[n][i].element).attr("data-highlight", "select");
    }    
}
