
load_package flow
package require cmdline

proc make_all_pins_virtual { project_name project_rev } {

    project_open $project_name -revision $project_rev

    remove_all_instance_assignments -name VIRTUAL_PIN
    set name_ids [get_names -filter * -node_type pin]

    foreach_in_collection name_id $name_ids {
        set pin_name [get_name_info -info full_path $name_id]

        if { -1 == [lsearch -exact { clock clock2x } $pin_name] } {
            post_message "Making VIRTUAL_PIN assignment to $pin_name"
            set_instance_assignment -to $pin_name -name VIRTUAL_PIN ON
        } else {
            post_message "Skipping VIRTUAL_PIN assignment to $pin_name"
        }
    }
    export_assignments
}

set module       [lindex $quartus(args) 0]
set project_name [lindex $quartus(args) 1]
set project_rev  [lindex $quartus(args) 2]

if [string match "quartus_map" $module] {
    make_all_pins_virtual $project_name $project_rev
}
